/*
 * This file contains javascript functions required by 
 * coppermine-browser.php for the Wordpress Coppermine 
 * Integration plugin.
 *
 * http://www.stilglog.com/wordpress-plugins/coppermine-plugin/
 *
 * copyright (c) 2005 Martijn van der Kwast
 */

var browser_type="IE";

function cpg_detectBrowser()
{
	if (navigator.userAgent.indexOf("Opera")!=-1 && document.getElementById) browser_type="opera"; // opera <=6
	else if (navigator.appName == "Microsoft Internet Explorer" || document.all) browser_type="ie";     // all versions
	else if (document.layers) browser_type="netscape";                        // 4.x
	else if (!document.all && document.getElementById) browser_type="gecko";  // w3c, mozilla
}
	
cpg_detectBrowser();

/*
 from quicktags.js included in WordPress, by 
 Alex King (http://www.alexking.org/)
 duplicated here because on Safari quicktags are 
 disabled, which means edInsertContent is not 
 available.

 FIXME: you cannot select the textare with myField 
        if tinyMCE is enabled
*/
function cpg_edInsertContent(myField, myValue) {

	if (typeof(tinyMCE) == 'undefined') {

		// STANDARD HTML TEXTAREA
		
		//IE support
		if (document.selection) {
			myField.focus();
			sel = document.selection.createRange();
			sel.text = myValue;
			myField.focus();
		}
		//MOZILLA/NETSCAPE support
		else if (myField.selectionStart || myField.selectionStart == '0') {
			var startPos = myField.selectionStart;
			var endPos = myField.selectionEnd;
			myField.value = myField.value.substring(0, startPos)
						  + myValue 
						  + myField.value.substring(endPos, myField.value.length);
			myField.focus();
			myField.selectionStart = startPos + myValue.length;
			myField.selectionEnd = startPos + myValue.length;
		} else {
			myField.value += myValue;
			myField.focus();
		}
	}
	else {
		// TINYMCE SUPPORT
		tinyMCE.execInstanceCommand('mce_editor_0','mceInsertContent', false, myValue);
	}
}

/* From 'quicktags.js' -- I don't want to include the whole .js file just
 * for one function..  */
function cpg_popup_insert_image(pid) {
	var ta=opener.document.getElementById("content");

	// type (image/thumb)
	var st=document.getElementById("cpg-image-insert-select-type").value;

	// align
	var al=document.getElementById("cpg-image-insert-select-style").value;

	// shadow
	var shadow=document.getElementById("cpg-image-insert-select-shadow").value;

	// link style
	var link=document.getElementById("cpg-image-insert-select-linktype").value;

	// condition
	//var cond=document.getElementById("cpg-image-insert-gcd").value;
	
	var opts=pid+':'+al;
	if (shadow!='')
		opts+=':s='+shadow;
	if (link)
		opts+=':l='+link;

	var opts=pid+':'+al;
	if (shadow!='')
		opts+=':s='+shadow;
	if (link)
		opts+=':l='+link;
//	if (cond)
//		opts+=':i='+cond;

	if (st=="thumbnail") {
		opener.cpg_edInsertContent(ta,"[thumb:"+opts+"]");
	}
	else {
		opener.cpg_edInsertContent(ta,"[image:"+opts+"]");
	}
}

function cpg_popup_insert_album(aid)
{
	var ta=opener.document.getElementById("content");
	var al=document.getElementById("cpg-image-insert-select-style").value;
	opener.cpg_edInsertContent(ta,'[album:'+aid+':'+al+']');
}

/* Thank you Rasmus <http://www.phpcommunity.org/gazette/2005/aug/threads_of_interest.html>, and
 * Christine Davis <http://www.neato.co.nz/ultimate-tag-warrior/> of course, for showing me the way
 * in her Ultimate-Tag-Warrior */

function createRequestObject() {
    var ro;
    if(browser_type=="ie") {
        ro = new ActiveXObject("Microsoft.XMLHTTP");
    }else{
        ro = new XMLHttpRequest();
    }
    return ro;
}

var http = createRequestObject();

function sndReq(action) {
	var uri=cpg_rpcurl+'?'+action;
	changeDiv('mainbox','One moment please !'); // +uri);
	http.open('get', uri);
    http.onreadystatechange = handleResponse;
    http.send(null);
}

function handleResponse() {
    if(http.readyState == 4){
        changeDiv('mainbox',http.responseText);
    }
}

function changeDiv(id, str) {
	
	if (browser_type=="opera" || browser_type=="gecko") {
		document.getElementById(id).innerHTML = str;
	} else if (browser_type=="ie") {
		document.all[id].innerHTML = str;
	} else if (browser_type=="netscape") {
		document.layers[id].document.open();
		document.layers[id].document.write(str);
		document.layers[id].document.close();
	}
}

function openAlbum(id) {
	changeDiv('mainbox','Request sent');
	sndReq('action=getalbum&aid='+id);
}

