<?php

/*
 * This file is Copyright (c) 2005 by Martijn van der Kwast <mvdkwast@gmx.net>
 * and part of the Coppermine Integration plugin for WordPress.
 */

require_once('../../../wp-blog-header.php');
require_once(ABSPATH . 'wp-content/plugins/coppermine/coppermine.php');

cpg_connect();

$action=$_REQUEST['action'];

switch($action) {
	case 'debug':
		print 'debug...';
		break;
	
	case 'getalbum':
		get_album($_REQUEST['aid']);
		break;
}

/*
 * Make sure the title fits in the picturebox
 * truncs string / insert spaces
 */
function cut_in_pieces($str, $l=8,$m=55) {

	/*
	 * construct array from utf-8 string,
	 * 1 element/displayed character
	 */
	
	$chars=array();
	$strw=$str;
	while (strlen($strw)) {
		$rx='/^(&\w+;|&#\d+;|&#x[0-9A-Fa-f]+;)/u';
		if (preg_match($rx,$strw,$matches)) {
			array_push($chars,$matches[0]);
			$strw=preg_replace($rx,'', $strw);
		}
		else {
			array_push($chars,$strw[0]);
			$strw=substr($strw,1);
		}
	}

	/* 
	 * force spaces every $l characters/entities and
	 * trunc string at $m
	 */
	
	$str = '';
	$sc = 0;
	$len=count($chars);
	$last=$m;
	for ($i=0; $i<$last && $i<$len; ++$i) {
		$char=$chars[$i];
		if ($char==' ' || $char=='\t') {
			$str.=' ';
			$sc=0;
		} else {
			$sc++;
			if ($sc>$l) {
				// if only soft-hyphens were supported
				$str.='<span style="font-size: 0px; width: 0px;"> </span>';
				$sc=0;
				$last--;
			} 
			$str.=$char;
		}
	}
	
	return $str;
}


function get_album($aid) {
	global $cpg_uri;
	global $cpg_base;
	
	$images = cpg_db_get_album_images($aid);
	$album = cpg_db_get_albumdata($aid);
	$w=0;
	$count=count($images);

	print '<div class="album">';
	
	print '<h2><a class="album-title" title="Insert this album" href="#" onClick="cpg_popup_insert_album('.$aid.')">'.$album->title.'</a></h2>';
	print '<div class="album-count">';
	print $count.' image';
	print ($count==1)?'':'s';
	print '</div>';
	
	$i=0;
	while($i<$count) {
		$mh=90;
		for ($j=0; $j<3; $j++) {
			if ($i+$j>=$count)
		   		break;
			$image=$images[$i+$j];

			$w=$image->pwidth;
			$h=$image->pheight;
			if ($w) {
				$ratio = $h/$w;
				$h = intval(120.0 * $ratio);
			} 
			if ($h>$mh) {
				$mh=$h;
			}
		}

		$h=$mh+6;
		$th=$h;
		$rh=$h+50;

		echo '<div class="album-row" style="height: '.$rh.'px;">';
		
		$left=0;
		for ($j=0; $j<3; $j++) {
			if ($i+$j>=$count)
		   		break;

			$image=$images[$i+$j];
			$uri = $cpg_uri.$image->filepath;
			$thumb = $uri.'thumb_'.$image->filename;
			$title = "Insert {$image->title} ({$image->filename})";

			// make nice label
			$label = $image->title;
			if (empty($label)) $label=$image->filename;
			$label=cut_in_pieces($label);
			// $label = $image->title;
			
			$w=$image->pwidth;
			$h=$image->pheight;
			if ($w) {
				$ratio = $h/$w;
				$h = intval(120.0 * $ratio);
			} 
			if (!$h) $h=90;
			$top=($th-$h)/2;
			
			echo '<div class="image-box" style="left: '.$left.'px; height: '.($rh-4).'px;">';
			echo '  <div class="album-image" style="top: '.$top.'px; ">';
			echo '     <img src="'.$thumb.'" alt="'.$title.'" title="'.$title.'" onclick="cpg_popup_insert_image('.$image->pid.');" />';
			echo '   </div>';
			echo '   <div style="top: '.($rh-50).'px;" class="image-label">'.$label.'</div>';
			echo '</div>';

			$left+=132;
		}

		echo '</div>';
			
		$i+=3;
	}
			
	print '</div>'; // album
}

?>
